做了几场多校下来,发现自己的思维太狭隘,不够灵活,思考的方向不正确,感觉越来越受限制。多刷点cf没坏处。
http://acm.hdu.edu.cn/showproblem.php?pid=4961
给出一个序列a[],若a[i]前面有它的倍数,那么将b[i]赋值为离他最近的那个倍数,否则赋值为a[i],若a[i]后面有它的倍数,那么将c[i]赋值离他最近的那个数,否则赋值为a[i],求b[i]*c[i]的和。
若a[i]前面有它的倍数,那么a[i]一定是那个数的约数,当扫描到那个数时,去更新它的所有约数,再次扫描到a[i]时就知道离他最近的倍数了。求c[i]也一样。
#include <stdio.h> #include <iostream> #include <map> #include <set> #include <list> #include <stack> #include <vector> #include <math.h> #include <string.h> #include <queue> #include <string> #include <stdlib.h> #include <algorithm> #define LL __int64 #define eps 1e-12 #define PI acos(-1.0) using namespace std; const int INF = 0x3f3f3f3f; const int maxn = 100010; int a[maxn],b[maxn],c[maxn]; int vis[maxn];//vis[i]保存i的最近出现的倍数 vector<int>num[maxn]; //预处理约数 void init() { for(int i = 1; i <= 100000; i++) { for(int j = 1; j*i <= 100000; j++) num[i*j].push_back(i); } } int main() { init(); int n; while(~scanf("%d",&n)&&n) { for(int i = 1; i <= n; i++) scanf("%d",&a[i]); memset(vis,0,sizeof(vis)); for(int i = 1; i <= n; i++) { if(!vis[a[i]]) //a[i]的倍数还没出现,那么b[i] = a[i] b[i] = a[i]; else b[i] = vis[a[i]];//a[i]的倍数出现,赋值为最近的倍数 for(int j = 0; j < (int)num[a[i]].size(); j++) //更新a[i]的约数的vis vis[num[a[i]][j]] = a[i]; } memset(vis,0,sizeof(vis)); for(int i = n; i >= 1; i--) { if(!vis[a[i]]) c[i] = a[i]; else c[i] = vis[a[i]]; for(int j = 0; j < (int)num[a[i]].size(); j++) vis[num[a[i]][j]] = a[i]; } LL sum = 0; for(int i = 1; i <= n; i++) { sum += (LL)b[i] * (LL)c[i]; } printf("%I64d\n",sum); } return 0; return 0; }
http://acm.hdu.edu.cn/showproblem.php?pid=4970
每座塔都有一个攻击范围[l,r],这区间每个点的攻击值为d,有k个怪兽,已知它初始的位置x和生命值h,要径直走到n点,问最后没被打死的怪兽的数目。
一看题意,感觉是赤裸裸的线段树,后来陷入TLE。当时nc的坚信是线段树,一直在线段树上优化。真是挫。
<strong><span style="font-size:14px;">#include <stdio.h> #include <iostream> #include <map> #include <set> #include <list> #include <stack> #include <vector> #include <math.h> #include <string.h> #include <queue> #include <string> #include <stdlib.h> #include <algorithm> #define LL __int64 #define eps 1e-12 #define PI acos(-1.0) using namespace std; const int INF = 0x3f3f3f3f; const int maxn = 100010; LL a[maxn]; int l,r,x; LL h,d; int main() { int n,m,k; while(scanf("%d",&n)&&n) { scanf("%d",&m); memset(a,0,sizeof(a)); for(int i = 1; i <= m; i++) { scanf("%d %d %I64d",&l,&r,&d); a[l] += d; a[r+1] -= d; } for(int i = 2; i <= n; i++) { a[i] += a[i-1]; } for(int i = n-1; i >= 1; i--) a[i] += a[i+1]; scanf("%d",&k); int cnt = 0; for(int i = 1; i <= k; i++) { scanf("%I64d %d",&h,&x); if(a[x] < h) cnt += 1; } printf("%d\n",cnt); } return 0; }</span></strong>
两个队打篮球,一次可以得1,2,3分,现在有n个记录,只记录了两个队得分的差的绝对值,问他们最后的得分共有几种情况。
因为最后的差值是确定的,所以只需求出最后的和有多少种。只有差值序列1-2和2-1对和的贡献有两种,其他都只有一种,所以判断1-2或2-1这样的序列有cnt个。那么最后的和共有cnt+1种,比分结构就有2*(cnt+1)种,当最后差值是0的时候比分结果有cnt+1种。
<span style="font-size:14px;"><strong>#include <stdio.h> #include <iostream> #include <map> #include <set> #include <list> #include <stack> #include <vector> #include <math.h> #include <string.h> #include <queue> #include <string> #include <stdlib.h> #include <algorithm> #define LL __int64 #define eps 1e-12 #define PI acos(-1.0) using namespace std; const int INF = 0x3f3f3f3f; const int maxn = 100010; int main() { int test; int n,a[maxn]; scanf("%d",&test); for(int item = 1; item <= test; item++) { scanf("%d",&n); for(int i = 1; i <= n; i++) { scanf("%d",&a[i]); } int cnt = 0; int flag = 1; a[0] = 0; for(int i = 1; i <= n; i++) { if(a[i] - a[i-1] > 3 || (a[i] == a[i-1] && a[i] != 1)) { flag = 0; break; } if((a[i] == 1 && a[i-1] == 2) || (a[i] == 2 && a[i-1] == 1)) cnt++; } printf("Case #%d: ",item); if(flag == 1) { if(a[n] == 0) printf("%d\n",cnt+1); else printf("%d\n",2*cnt+2); } else printf("0\n"); } return 0; }</strong></span>
http://acm.hdu.edu.cn/showproblem.php?pid=4974
有n个队打比赛,每次裁判可以给他们同时加1分,有一个队加1分或都不加,现在已知每个队的得分,问最少需要几场比赛变为现在的得分。
贪心,假设每次比赛每个队都的1分,这样比赛场数才尽可能小。那么每个队得分的和除以2就是场数,若有队的得分比它大,去最大的那个得分。
#include <stdio.h> #include <iostream> #include <map> #include <set> #include <list> #include <stack> #include <vector> #include <math.h> #include <string.h> #include <queue> #include <string> #include <stdlib.h> #include <algorithm> #define LL __int64 #define eps 1e-12 #define PI acos(-1.0) using namespace std; const int INF = 0x3f3f3f3f; const int maxn = 50010; int main() { int test,n; scanf("%d",&test); for(int item = 1; item <= test; item++) { scanf("%d",&n); LL Max = -1,x; LL sum = 0; for(int i = 1; i <= n; i++) { scanf("%I64d",&x); Max = max(Max,x); sum += x; } printf("Case #%d: %I64d\n",item,max((sum+1)/2,(LL)Max)); } return 0; }